"use strict";

var httpProxy = require('http-proxy');
var http = require('http');

var current_proxy = 0;
var total_workers = 0;

function next_proxy() {
	var proxy = proxies[current_proxy];
	current_proxy = (current_proxy + 1) % total_workers;
	return proxy;
}


var stickers = {};

var proxies = {};


exports.init = function(workers, first_port, proxy_port, session_hash, no_sockets) {

	var total_workers = workers;
	
	for (var n = 0; n < total_workers; n++) {
		proxies[n] = new httpProxy.createProxyServer({
			target : {
				host : '127.0.0.1',
				port : first_port + n
			}
		});
	}

	var server = http.createServer(function(req, res) {
		get_proxy(req, session_hash).web(req, res);
	});

	if (!no_sockets)
	{
		server.on('upgrade', function(req, socket, head) {
			get_proxy(req).ws(req, socket, head);
	
		});
	}

	server.listen(proxy_port);
}


function get_proxy(req, session_hash)
{
	var hash = session_hash(req);

	console.log('hash: ' + hash);

	if (hash !== undefined) {

		if (stickers[hash] !== undefined) {

			console.log('restored proxy.');

			proxy = stickers[hash].proxy;
		} else {

			proxy = next_proxy();

			stickers[hash] = {
				proxy : proxy,
			}

			console.log('assigned proxy.');
		}

	} else {

		console.log('random proxy.');

		proxy = next_proxy();
	}

	return proxy;
}
